package cert;
import java.io.*;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
/*
import java.security.cert.CRLException;
import java.util.List;
import sun.security.x509.X509CertImpl;
import sun.security.x509.CRLDistributionPointsExtension;
import sun.security.x509.DistributionPoint;
import sun.security.x509.GeneralName;
import sun.security.x509.X509CRLImpl;
*/
import java.util.Date;


public class ReadExistingCertificate {

	public static void main(String[] args){
		
		// modificare la stringa path
		String path = ""; 
		String acCert = path + "servera.almachannel.unibo.it.crt";
		String rsaCert2048 = path + "BuiltinObjectToken-RSASecurity2048v3.crt";
		String thawte = path + "thawteExtendedValidationSSLCA.crt";
		
		try {

			// Reading an exististing Certificate
			
			//InputStream is = new FileInputStream(thawte);
			//InputStream is = new FileInputStream(rsaCert2048);
			InputStream is = new FileInputStream(acCert);
			CertificateFactory fact = CertificateFactory.getInstance("X.509", "BC");			
			X509Certificate x509cert = (X509Certificate)fact.generateCertificate(is);
			is.close();
			
			System.out.println("*************** ");
			System.out.println("Version: " + x509cert.getVersion());
			System.out.println("Serial number: " + x509cert.getSerialNumber());
			System.out.println("Signature algorithm name: " + x509cert.getSigAlgName());

			System.out.println("Issuer: " + x509cert.getIssuerX500Principal());
			System.out.println("Not before: " + x509cert.getNotBefore());
			System.out.println("Not after: " + x509cert.getNotAfter());
			
			System.out.println("Subject name: " + x509cert.getSubjectX500Principal());
			System.out.println("Subject public key algorithm: " + x509cert.getPublicKey().getAlgorithm());
			System.out.println("Subject public key: " + x509cert.getPublicKey());
		
			System.out.println("*************** ");
			
			// Basic validation
			System.out.println("Validating dates...");
			x509cert.checkValidity(new Date());
			System.out.println("Verifying signature...");
			x509cert.verify(x509cert.getPublicKey());
			System.out.println("Dates and signature verified.");
				
		}
		
		catch(Exception e){
			e.printStackTrace();
		}
		
		
		
	}
	
	
	
}
